Gecode::Int::Channel::LinkMulti Class Reference
Other available functionality » Integer propagators

Link propagator for multiple Boolean views. More...

`#include <channel.hh>`

## Public Member Functions

virtual Actor * | copy (Space &home)
| Copy propagator during cloning.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (low unary if y is assigned, low linear otherwise).
virtual void | reschedule (Space &home)
| Schedule function.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Give advice to propagator.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, ViewArray< BoolView > &x, IntView y, int o)
| Post propagator for .
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Additional Inherited Members

Protected Member Functions inherited from Gecode::MixNaryOnePropagator< BoolView, PC_BOOL_NONE, IntView, PC_INT_DOM >
| MixNaryOnePropagator (Space &home, MixNaryOnePropagator &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.
Protected Attributes inherited from Gecode::MixNaryOnePropagator< BoolView, PC_BOOL_NONE, IntView, PC_INT_DOM >
ViewArray< BoolView > | x
| Array of views.
IntView | y
| Single view.

## Detailed Description

Link propagator for multiple Boolean views.

Requires

#include <gecode/int/channel.hh>
channel.hh

Definition at line 197 of file channel.hh.

## Member Function Documentation

## copy()

Actor * Gecode::Int::Channel::LinkMulti::copy | ( | Space & | home | ) |

virtual

Copy propagator during cloning.

Implements Gecode::Actor.

Definition at line 82 of file link-multi.cpp.

## cost()

PropCost Gecode::Int::Channel::LinkMulti::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function (low unary if y is assigned, low linear otherwise).

Reimplemented from Gecode::MixNaryOnePropagator< BoolView, PC_BOOL_NONE, IntView, PC_INT_DOM >.

Definition at line 97 of file link-multi.cpp.

## reschedule()

void Gecode::Int::Channel::LinkMulti::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Reimplemented from Gecode::MixNaryOnePropagator< BoolView, PC_BOOL_NONE, IntView, PC_INT_DOM >.

Definition at line 105 of file link-multi.cpp.

## advise()

ExecStatus Gecode::Int::Channel::LinkMulti::advise | ( | Space & | home,
|  | Advisor & | a,
|  | const Delta & | d )

virtual

Give advice to propagator.

Reimplemented from Gecode::Propagator.

Definition at line 112 of file link-multi.cpp.

## propagate()

ExecStatus Gecode::Int::Channel::LinkMulti::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 122 of file link-multi.cpp.

## post()

ExecStatus Gecode::Int::Channel::LinkMulti::post | ( | Home | home,
|  | ViewArray< BoolView > & | x,
|  | IntView | y,
|  | int | o )

inline static

Post propagator for .

Definition at line 53 of file link-multi.hpp.

## dispose()

size_t Gecode::Int::Channel::LinkMulti::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::MixNaryOnePropagator< BoolView, PC_BOOL_NONE, IntView, PC_INT_DOM >.

Definition at line 87 of file link-multi.cpp.

The documentation for this class was generated from the following files:

- gecode/int/channel.hh
- gecode/int/channel/link-multi.cpp
- gecode/int/channel/link-multi.hpp